<?php
/**
 * PAYGENT B2B MODULE
 * PaygentB2BModuleLogger.php
 * 
 * Copyright (C) 2007 by PAYGENT Co., Ltd.
 * All rights reserved.
 */

define('LOG4PHP_DIR', 'log4php');
require_once(LOG4PHP_DIR . '/LoggerManager.php');
require_once(LOG4PHP_DIR . '/layouts/LoggerPatternLayout.php');
require_once(LOG4PHP_DIR . '/appenders/LoggerAppenderFile.php');

include_once("jp/co/ks/merchanttool/connectmodule/exception/PaygentB2BModuleException.php");
include_once("jp/co/ks/merchanttool/connectmodule/system/PaygentB2BModuleResources.php");

/**
 * ڑW[p Logger NX
 * 
 * @version $Revision: 1.4 $
 * @author $Author: t-mori $
 */

	/** Logo̓p^[ */
	define("PaygentB2BModuleLogger__PATTERN", "%d{Y/m/d H:i:s} %-5p %c %m%n");


class PaygentB2BModuleLogger {

	/** loggerێ */
	//var $instance = null;

	/** FileAppender ێ */
	var $appender = null;

	/**
	 * RXgN^
	 */
	function PaygentB2BModuleLogger() {
		$layout = new LoggerPatternLayout();
		$layout->setConversionPattern(PaygentB2BModuleLogger__PATTERN);
		$layout->activateOptions();
		$this->appender = new LoggerAppenderFile("FileLogger");
		$this->appender->setLayout($layout);
		
		$inst = PaygentB2BModuleResources::getInstance();
		if (is_object($inst) && 
			!StringUtil::isEmpty($inst->getLogOutputPath())) {
			$this->appender->setFile($inst->getLogOutputPath(), true);
			$this->appender->activateOptions();
		} else {
			$this->appender = null;
			trigger_error("Cannot get log file.", E_USER_WARNING);
		}
	}
	
	/**
	 * PaygentB2BModuleLogger 擾
	 * 
	 * @return PaygentB2BModuleLogger
	 */
	function &getInstance() {
		static $logInstance = null;		
		if (isset($logInstance) == false
			|| $logInstance == null
			|| is_object($logInstance) != true) {

			$logInstance = new PaygentB2BModuleLogger();
			if ($logInstance->appender == null) {
				$logInstance = null;
			}
		}
		return $logInstance;
	}

	/**
	 * fobOOo
	 * 
	 * @param className String Ȍo͌NX o͌
	 * @param message Object ObZ[W
	 * @param throwable Throwable
	 */
	function debug($className, $message, $throwable = null) {
		$log = &LoggerManager::getLogger($className);
		$log->setLevel(LoggerLevel::getLevelDebug());
		$log->addAppender($this->appender);
		$log->debug($message, $throwable);
	}

	/**
	 * CtHOo
	 * 
	 * @param className String Ȍo͌NX o͌
	 * @param message Object ObZ[W
	 * @param throwable Throwable
	 */
	function info($className, $message, $throwable = null) {
		$log = &LoggerManager::getLogger($className);
		$log->setLevel(LoggerLevel::getLevelDebug());
		$log->addAppender($this->appender);
		$log->info($message, $throwable);
	}

	/**
	 * [jOOo
	 * 
	 * @param className String Ȍo͌NX o͌
	 * @param message Object ObZ[W
	 * @param throwable Throwable
	 */
	function warn($className, $message, $throwable = null) {
		$log = &LoggerManager::getLogger($className);
		$log->setLevel(LoggerLevel::getLevelDebug());
		$log->addAppender($this->appender);
		$log->info($message, $throwable);
	}

	/**
	 * G[Oo
	 * 
	 * @param className String Ȍo͌NX o͌
	 * @param messageObject ObZ[W
	 * @param throwable Throwable
	 */
	function error($className, $message, $throwable = null) {
		$log = &LoggerManager::getLogger($className);
		$log->setLevel(LoggerLevel::getLevelDebug());
		$log->addAppender($this->appender);
		$log->error($message, $throwable);
	}

	/**
	 * tF[^Oo
	 * 
	 * @param className String Ȍo͌NX o͌
	 * @param message Object ObZ[W
	 * @param throwable Throwable
	 */
	function fatal($className, $message, $throwable = null) {
		$log = &LoggerManager::getLogger($className);
		$log->setLevel(LoggerLevel::getLevelDebug());
		$log->addAppender($this->appender);
		$log->fatal($message, $throwable);
	}

}

?>
